package esercizio1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Random;

public class GestioneFile {
	public GestioneFile() {
	}

	private String stringaCasuale() {
		String[] alfabeto = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "l", "m", "n", "o", "p", "q", "r", "s", "t",
				"u", "v", "z" };
		Random r = new Random();
		// Almeno un carattere
		int lunghezza = r.nextInt(10)+1;
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < lunghezza; i++) {
			int indice = r.nextInt(alfabeto.length);
			builder.append(alfabeto[indice]);
		}
		return builder.toString();
	}

	private Integer numeroCasuale() {
		Random r = new Random();
		int n = r.nextInt(100);
		return n;
	}

	public void generaFile(String nomeFile) {
		int numeroElementi = numeroCasuale();
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(nomeFile));
			for (int i = 0; i < numeroElementi; i++) {
				if (numeroCasuale() % 2 == 0)
					writer.append(numeroCasuale()+"");
				else
					writer.append(stringaCasuale());
				//Non stampiamo il fine linea per l'ultimo elemento
				if(i != numeroElementi-1)
					writer.newLine();
			}
			writer.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + nomeFile);
		}
	}

	private ArrayList<String> leggi(String nomeFile) {
		ArrayList<String> a = new ArrayList<String>();
		try {
			BufferedReader b = new BufferedReader(new FileReader(nomeFile));
			while (b.ready()) {
				a.add(b.readLine());
			}
			b.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + nomeFile);
		}
		return a;
	}

	public void leggiFile(String nomeFile) {
		ArrayList<String> elements = leggi(nomeFile);
		for (String e : elements)
			System.out.println(e);
	}

	private boolean convertibileInNumero(String s) {
		try {
			Integer.parseInt(s);
		} catch (NumberFormatException e) {
			return false;
		}
		return true;
	}

	private ArrayList<Integer> calcolaNumeri(String nomeFile) {
		ArrayList<String> elements = leggi(nomeFile);
		ArrayList<Integer> numeri = new ArrayList<Integer>();
		for (String e : elements) {
			if (convertibileInNumero(e)) {
				numeri.add(Integer.parseInt(e));
			}
		}
		return numeri;
	}

	public void calcolaMinimo(String nomeFile) {
		System.out.println(Collections.min(calcolaNumeri(nomeFile)));
	}

	public void calcolaMassimo(String nomeFile) {
		System.out.println(Collections.max(calcolaNumeri(nomeFile)));
	}

	public void ordina(String nomeFile) {
		ArrayList<String> elements = leggi(nomeFile);
		Collections.sort(elements, new Comparator<String>() {

			@Override
			public int compare(String o1, String o2) {
				if (convertibileInNumero(o1) && !convertibileInNumero(o2))
					return -1;

				if (!convertibileInNumero(o1) && convertibileInNumero(o2))
					return 1;
				
				if (convertibileInNumero(o1) && convertibileInNumero(o2)) {
					Integer n1 = Integer.parseInt(o1);
					Integer n2 = Integer.parseInt(o2);
					return n1.compareTo(n2);
				}					

				if (o1.length() < o2.length())
					return -1;

				if (o1.length() > o2.length())
					return 1;

				return o1.compareTo(o2);
			}
		});
		for (String e : elements)
			System.out.println(e);
	}
	
	public static void main(String[] args) {
		GestioneFile g = new GestioneFile();
//		g.generaFile("test.txt");
		g.leggiFile("test.txt");
		g.calcolaMassimo("test.txt");
		g.calcolaMinimo("test.txt");
		g.ordina("test.txt");
	}
}
