package esercizio3;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

public class ElencoTelefonico {

	private HashMap<String, String> elencoTelefonico;
	
	public ElencoTelefonico() {
		elencoTelefonico = new HashMap<String, String>();		
	}
	
	public void aggiungiUtente(String idUtente, String numeroTelefonico) {
		elencoTelefonico.put(idUtente, numeroTelefonico);
	}
	
	public String getNumeroTelefonico(String idUtente) {
		return elencoTelefonico.get(idUtente);
	}
	
	public void salvaElenco(String filename) {
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(filename));
			int cont = 0;
			for(String s : elencoTelefonico.keySet()) {
				writer.append(s+":"+elencoTelefonico.get(s));
				//Non mettiamo una linea vuota alla fine
				if(cont != elencoTelefonico.size()-1)
					writer.newLine();
				cont++;
			}			
			writer.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + filename);
		}			
	}
	
	public void leggiElenco(String filename) {
		try {
			BufferedReader b = new BufferedReader(new FileReader(filename));
			while (b.ready()) {
				String line = b.readLine();
				String[] elements = line.split(";");
				if(elements.length == 2)
					elencoTelefonico.put(elements[0], elements[1]);
			}
			b.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + filename);
		}
	}
	
	public static void main(String[] args) {
		ElencoTelefonico e = new ElencoTelefonico();
//		e.aggiungiUtente("aldo", "1111111111");
//		e.aggiungiUtente("francesco", "1111111112");
//		e.aggiungiUtente("marco", "1111111113");
//		e.salvaElenco("elencoTelefonico.txt");
		e.leggiElenco("elencoTelefonico.txt");
		System.out.println(e.getNumeroTelefonico("aldo"));
	}
}
